【codeforces1081C】 Colorful Bricks(DP 排列组合)

这篇博客介绍了如何解决一个关于涂色砖块的问题,其中涉及动态规划(DP)和组合数学。题目要求计算在一定数量的砖块和颜色中,有多少种方式涂色,使得特定数量的砖块颜色与其左侧不同。博客提供了两种解决方案,一种是使用组合数学的计算方法,另一种是通过动态规划的状态转移方程来求解,并给出了相应的代码实现。
摘要由CSDN通过智能技术生成

Description

On his free time, Chouti likes doing some housework. He has got one new task, paint some bricks in the yard.

There are n bricks lined in a row on the ground. Chouti has got m paint buckets of different colors at hand, so he painted each brick in one of those m colors.

Having finished painting all bricks, Chouti was satisfied. He stood back and decided to find something fun with these bricks. After some counting, he found there are k bricks with a color different from the color of the brick on its left (the first brick is not counted, for sure).

So as usual, he needs your help in counting how many ways could he paint the bricks. Two ways of painting bricks are different if there is at least one brick painted in different colors in these two ways. Because the answer might be quite big, you only need to output the number of ways modulo 998244353.

Input

The first and only line contains three integers n, m and k (1≤n,m≤2000,0≤k≤n−1) — the number of bricks, the number of colors, and the number of bricks, such that its color differs from the color of brick to the left of it.

Output

Print one integer — the number of ways to color bricks modulo 998244353
.

Sample Input

Input
3 3 0
Output
3
Input
3 2 1
Output
4

题意:n代表的有n个格子,m代表有m种颜色,k代表有k个格子的左边第一个是与他不同的颜色

思路:
1.组合数学
因为第一个格子不会影响其他的格子,所以第一个格子有m种颜色,从剩的n-1个格子中挑选k个,因为这个格子与左边的不同,所以这个格子能取的颜色是m-1种
所以公式为
m ∗ C k n − 1 ∗ ( m − 1 ) k m*C_k^{n-1}*(m-1)^k m</

  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值